package com.fp.persistence.pcustomer.gene;

import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;
import javax.persistence.Version;
import java.lang.reflect.Field;
import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TCUSTPERSONPARAMETERSID*/
@Entity(name="TcustPersonParametersId")
@Table(name="TCUSTPERSONPARAMETERSID")
public class TcustPersonParametersId extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TcustPersonParametersId
*/
@Id
@Column(name="IDENTIFICATIONCATALOG" ,nullable=false, updatable=false)
private String pk;
@Column(name="IDENTIFICATIONCATALOGCODE", nullable=true)

/**
* Codigo de tabla de catalogo IDENTIFICATION
*/
private String identificationcatalogcode;

@Column(name="MAXLENGTH", nullable=true)

/**
* Tamaño maximo del tipo de identificacion
*/
private Integer maxlength;

@Column(name="PERMITLETTER", nullable=true)

/**
* Y si el tpo de identificación permite letras N si no permite
*/
private String permitletter;

@Column(name="NAMEBEAN", nullable=true)

/**
* Nombre del bean que contiene la rutina de validacion del tipo de identificacion
*/
private String namebean;

/**Contructor por defecto*/
public TcustPersonParametersId(){
}
/**Contructor de TcustPersonParametersId
@param pPk Clave Primaria del entity
*/
public TcustPersonParametersId(String pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TcustPersonParametersId
*/
public static TcustPersonParametersId find(EntityManager pEntityManager,Object pKey) throws Exception{
    TcustPersonParametersId obj = pEntityManager.find(TcustPersonParametersId.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TcustPersonParametersId
@return El objeto que referencia a la Clave primaria de TcustPersonParametersId
*/
public String getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TcustPersonParametersId
@param pPk El objeto que referencia a la nueva Clave primaria de TcustPersonParametersId
*/
public void setPk(String pPk){
  pk=pPk;
}
/**Obtiene el valor de identificationcatalogcode
@return valor de identificationcatalogcode*/
public String getIdentificationcatalogcode(){
  return identificationcatalogcode;
}
/**Fija el valor de identificationcatalogcode
@param pIdentificationcatalogcode nuevo Valor de identificationcatalogcode*/
public void setIdentificationcatalogcode(String pIdentificationcatalogcode){
  identificationcatalogcode=pIdentificationcatalogcode;
}

/**Obtiene el valor de maxlength
@return valor de maxlength*/
public Integer getMaxlength(){
  return maxlength;
}
/**Fija el valor de maxlength
@param pMaxlength nuevo Valor de maxlength*/
public void setMaxlength(Integer pMaxlength){
  maxlength=pMaxlength;
}

/**Obtiene el valor de permitletter
@return valor de permitletter*/
public String getPermitletter(){
  return permitletter;
}
/**Fija el valor de permitletter
@param pPermitletter nuevo Valor de permitletter*/
public void setPermitletter(String pPermitletter){
  permitletter=pPermitletter;
}

/**Obtiene el valor de namebean
@return valor de namebean*/
public String getNamebean(){
  return namebean;
}
/**Fija el valor de namebean
@param pNamebean nuevo Valor de namebean*/
public void setNamebean(String pNamebean){
  namebean=pNamebean;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TcustPersonParametersId))return false;
    TcustPersonParametersId that = (TcustPersonParametersId) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementación del metodo hashCode de la la entidad TcustPersonParametersId
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementación de la creación de un bean en blanco TcustPersonParametersId
*/
public Object createInstance(){
 TcustPersonParametersId instance=new TcustPersonParametersId();	
 return instance;
}
/**Clona la entidad TcustPersonParametersId
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TcustPersonParametersId p=(TcustPersonParametersId)this.clone();
  return p;
}
public Object getId() {
  return this.pk;
}
}
